OpenGrok revision 870
294N/A#!/bin/sh
294N/A#
787N/A# OpenGrok Wrapper (initial setup and cron job updating)
789N/A#
789N/A# Supported Operating Systems:
789N/A# - Solaris 10 (SunOS 5.10)
789N/A# - OpenSolaris (SunOS 5.11)
789N/A# - Debian (Linux)
789N/A#
789N/A# Supported Deployment Engines
789N/A# - Tomcat 6
789N/A# - Glassfish
294N/A#
789N/A# Supported Environment Variables :
789N/A# - OPENGROK_NON_INTERACTIVE Suppress Progress and Warnings Messages
789N/A# - OPENGROK_STANDARD_ENV Run Time Shell Environment (Shell Script)
789N/A# - OPENGROK_CONFIGURATION User Configuration (Shell Script)
789N/A#
789N/A# Supported Environment Variables for configuring the default setup
789N/A# - OPENGROK_DISTRIBUTION_BASE Base Directory of the OpenGrok Distribution
789N/A# - OPENGROK_INSTANCE_BASE Base Directory of the OpenGrok User Data Area
789N/A# - EXUBERANT_CTAGS Full Path to Exuberant CTags
789N/A# - JAVA_HOME Full Path to Java Installation Root
789N/A# - OPENGROK_APP_SERVER Application Server ("Tomcat" or "Glassfish")
789N/A# - OPENGROK_WAR_TARGET_TOMCAT Tomcat Specific WAR Target Directory
789N/A# - OPENGROK_WAR_TARGET_GLASSFISH Glassfish Specific WAR Target Directory
789N/A# - OPENGROK_WAR_TARGET Fallback WAR Target Directory
789N/A# - OPENGROK_TOMCAT_BASE Base Directory for Tomcat (contains webapps)
789N/A# - OPENGROK_GLASSFISH_BASE Base Directory for Glassfish (contains domains)
789N/A# - OPENGROK_GLASSFISH_DOMAIN Preferred Glassfish Domain Name
789N/A#
787N/A
294N/A#
294N/A# Usage
294N/A#
294N/A
294N/AUsage()
294N/A{
294N/A echo 1>&2
869N/A echo "Usage: ${0} <deploy|update|updateQuietly|updateConfiguration|usage>" 1>&2
869N/A echo " ${0} index [<directory>]" 1>&2
789N/A echo 1>&2
789N/A echo " Optional environment variables:" 1>&2
789N/A echo " OPENGROK_CONFIGURATION - location of your configuartion" 1>&2
789N/A echo " e.g. $ OPENGROK_CONFIGURATION=/var/opengrok/myog.conf ${0} ... " 1>&2
789N/A echo 1>&2
868N/A echo " See the code for more information on configuration options / variables" 1>&2
294N/A echo 1>&2
294N/A exit 1
294N/A}
294N/A
294N/A#
789N/A# Runtime Configuration
294N/A#
787N/A
789N/AOS_NAME="`/bin/uname -s`"
789N/AOS_VERSION="`/bin/uname -r`"
787N/A
869N/A# TODO: Handle symlinks correctly (especially in ${0})
869N/ASCRIPT_DIRECTORY="`dirname ${0}`"
869N/ASCRIPT_DIRECTORY="`cd ${SCRIPT_DIRECTORY}; pwd`"
869N/A
789N/A#
789N/A# Default Instance Configuration
789N/A#
789N/A
789N/ADefaultInstanceConfiguration()
789N/A{
294N/A # Use the built-in defaults. This section can be copied to its own
789N/A # file and tailored to your local requirements. Then simply set
294N/A # OPENGROK_CONFIGURATION=/path/to/your/configuration, before using
294N/A # this wrapper. It will save you hand editing in your settings
789N/A # on each new release. A sample cron(1M) entry might look like:
294N/A # 15 0 * * * OPENGROK_CONFIGURATION=/pkgs/etc/OpenGrok.sh /pkgs/sbin/OpenGrok updateQuietly
294N/A
294N/A # Note: It is not really possible to ever provided defaults for
294N/A # these values which will run in every UNIX-like environment.
294N/A # So I have provided a set which are functional for a given
294N/A # environment on which you can based you own configuration.
294N/A
789N/A # This has been updated to support more environment variables and
789N/A # operating systems, if you have any reasonably generic
789N/A # improvements please feel free to submit a patch.
787N/A
789N/A OPENGROK_INSTANCE_BASE="${OPENGROK_INSTANCE_BASE:-/var/opengrok}"
294N/A
869N/A LOGGER_CONFIG_FILE="logging.properties"
868N/A
789N/A if [ -z "${OPENGROK_DISTRIBUTION_BASE}" ]
789N/A then
869N/A if [ -d "${SCRIPT_DIRECTORY}/dist" -a \
869N/A -f "${SCRIPT_DIRECTORY}/dist/opengrok.jar" -a \
869N/A -f "${SCRIPT_DIRECTORY}/dist/source.war" \
869N/A ]
789N/A then
789N/A # Handle Developer Build Environments
869N/A OPENGROK_DISTRIBUTION_BASE="${SCRIPT_DIRECTORY}/dist"
869N/A LOGGER_CONF_SOURCE="${SCRIPT_DIRECTORY}/conf/${LOGGER_CONFIG_FILE}"
789N/A else
789N/A # Handle Binary Distributions
869N/A OPENGROK_DISTRIBUTION_BASE="${SCRIPT_DIRECTORY}"
869N/A LOGGER_CONF_SOURCE="${OPENGROK_DISTRIBUTION_BASE}/doc/${LOGGER_CONFIG_FILE}"
789N/A fi
787N/A fi
787N/A
294N/A # REQUIRED: Source Code/Repository Root
294N/A # (your source code or the root of all repositories)
789N/A SRC_ROOT="${OPENGROK_INSTANCE_BASE}/src"
294N/A
294N/A # REQUIRED: OpenGrok Generate Data Root
294N/A # (for Lucene index and hypertext cross-references)
294N/A # This area is rebuilt by "update" / "updateQuietly"
789N/A DATA_ROOT="${OPENGROK_INSTANCE_BASE}/data"
294N/A
294N/A # OPTIONAL: User Provided Source Path to Description Mapping (Tab Separated Value)
294N/A # (The user maintained source of the generated EftarFile file)
789N/A PATH_DESC="${OPENGROK_INSTANCE_BASE}/etc/paths.tsv"
294N/A
789N/A # REQUIRED: XML Configuration
294N/A # (the configuration used by Web/GUI interfaces)
789N/A XML_CONFIGURATION="${OPENGROK_INSTANCE_BASE}/etc/configuration.xml"
789N/A
869N/A # TODO: Verify that Logger Configuration is REQUIRED and not OPTIONAL
869N/A # REQUIRED: Logger Configuration
869N/A LOGGER_CONFIG_PATH="${OPENGROK_INSTANCE_BASE}/${LOGGER_CONFIG_FILE}"
869N/A LOGGER_PROPERTIES="-Djava.util.logging.config.file=${LOGGER_CONFIG_PATH}"
869N/A
789N/A # REQUIRED: Java Archive of OpenGrok (Installation Location)
857N/A OPENGROK_JAR="${OPENGROK_DISTRIBUTION_BASE}/opengrok.jar"
789N/A
789N/A # REQUIRED(deploy): Web Archive of OpenGrok (Distribution Location)
789N/A # (user building from source code will find this and other key
789N/A # files in the "dist" directory after the build is completed)
789N/A OPENGROK_DIST_WAR="${OPENGROK_DISTRIBUTION_BASE}/source.war"
294N/A
294N/A # REQUIRED: Exuberant CTags (http://ctags.sf.net)
789N/A EXUBERANT_CTAGS="${EXUBERANT_CTAGS:-`FindExuberantCTags`}"
294N/A
294N/A # REQUIRED: Java Home
789N/A JAVA_HOME="${JAVA_HOME:-`FindJavaHome`}"
294N/A export JAVA_HOME
294N/A
294N/A # REQUIRED: Java Virtual Machine
789N/A JAVA="${JAVA:-$JAVA_HOME/bin/java}"
294N/A
869N/A # OPTIONAL: Ignore these patterns as names of files or directories
869N/A #IGNORE_PATTERNS="-i dummy"
868N/A
869N/A # OPTIONAL: Enable Projects
869N/A # (Every directory in SRC_ROOT is considered a separate project)
869N/A ENABLE_PROJECTS="-P"
868N/A
789N/A # OPTIONAL: Scanning Options (for Mercurial repositories)
294N/A SCAN_FOR_REPOSITORY="-S"
294N/A
869N/A # OPTIONAL: Remote Repository Support (CVS or SVN)
869N/A # (Can be very time demanding, uncomment if needed)
869N/A #REMOTE_REPOSITORIES="-r on"
869N/A
869N/A # OPTIONAL: Allow Leading Wildcard Searches
869N/A # (default: off)
869N/A #LEADING_WILDCARD="-a on"
868N/A
869N/A # OPTIONAL: Web Site Look & Feel
869N/A # (Options: default, offwhite and polished.
869N/A # Note the quoting requirements)
869N/A #SKIN='-L "default"'
868N/A
870N/A # OPTIONAL: Set Maximum Indexed Words Per File
870N/A # Note, that you might run out of memory, then either increase JVM memory
870N/A # as noted in JAVA_OPTS, or set this limit(if you don't mind opengrok not
870N/A # indexing the rest of the file, once the limit is reached)
870N/A # (default: unlimited)
869N/A #MAX_INDEXED_WORDS="-m 100000"
869N/A
869N/A # OPTIONAL: Configuration Address (host:port)
869N/A # (conf/web.xml default is localhost:2424)
869N/A WEBAPP_CONFIG_ADDRESS="-U localhost:2424"
869N/A
869N/A # OPTIONAL: JVM Options
869N/A #JAVA_OPTS="-server -Xmx1024m"
868N/A
789N/A # OPTIONAL: Full Path to History Utilities
789N/A HG="`Which hg`"
789N/A CVS="`Which cvs`"
789N/A SVN="`Which svn`"
789N/A SCCS="`Which sccs`"
787N/A
294N/A # OPTIONAL: Override Built-in Properties
789N/A # Assumption: We should not set properties to the empty string
789N/A PROPERTIES="\
789N/A${HG:+-Dorg.opensolaris.opengrok.history.Mercurial=$HG} \
789N/A${CVS:+-Dorg.opensolaris.opengrok.history.cvs=$CVS} \
789N/A${SVN:+-Dorg.opensolaris.opengrok.history.Subversion=$SVN} \
789N/A${SCCS:+-Dorg.opensolaris.opengrok.history.SCCS=$SCCS} \
789N/A"
294N/A
869N/A # OPTIONAL: Store The History Cache in Java DB (derby),
869N/A # instead of file system (in gzipped xml files).
869N/A #
869N/A # Requirements:
869N/A # - derbyclient.jar - See README.txt for more details
869N/A # - Running Derby Server - Defaults to localhost:1527
869N/A #
869N/A #DERBY_HISTORY_CACHE=-D
294N/A
294N/A # DELIVERED: An update program for EftarFile
294N/A # Usage: <class> inputFile [inputFile ...] outputFile
294N/A # EftarFile == An Extremely Fast Tagged Attribute Read-only File System
294N/A EFTAR_UPDATE="org.opensolaris.opengrok.web.EftarFile"
294N/A
294N/A # HARDCODED: Generated EftarFile (See web/*.jsp)
294N/A EFTAR_OUTPUT_FILE="${DATA_ROOT}/index/dtags.eftar"
294N/A
294N/A # Be Quiet? (set indirectly by command line arguments in the main program)
869N/A #QUIET=""
294N/A
294N/A # or alternatively, Be Verbose!
869N/A #VERBOSE="-v"
789N/A}
789N/A
789N/A#
789N/A# Helper Functions - Logging
789N/A#
789N/A# In general, non-interactive use like cron jobs and automated
789N/A# installation environments should not generate unnecessary
789N/A# progress information or warnings, as usage and configuration
789N/A# will have generally been debugged prior to automation.
789N/A#
789N/A
789N/AProgress()
789N/A{
789N/A if [ -z "${OPENGROK_NON_INTERACTIVE}" ]
789N/A then
789N/A echo "${@}"
789N/A fi
789N/A}
789N/A
789N/AWarning()
789N/A{
789N/A if [ -z "${OPENGROK_NON_INTERACTIVE}" ]
789N/A then
789N/A echo "WARNING: ${@}" 1>&2
789N/A fi
789N/A}
789N/A
789N/AError()
789N/A{
789N/A echo "ERROR: ${@}" 1>&2
789N/A}
789N/A
789N/AFatalError()
789N/A{
789N/A echo 1>&2
789N/A echo "FATAL ERROR: ${@} - Aborting!" 1>&2
789N/A echo 1>&2
789N/A ${DO} exit 2
789N/A}
789N/A
789N/A#
789N/A# Helper Functions - Autodetection of Runtime Environment
789N/A#
789N/A
789N/AWhich()
789N/A{
789N/A path="`which ${1} 2>/dev/null`"
789N/A
789N/A if [ -x "${path}" ]
789N/A then
789N/A echo "${path}"
789N/A fi
789N/A}
294N/A
789N/AFindExuberantCTags()
789N/A{
789N/A case "${OS_NAME}:${OS_VERSION}" in
789N/A SunOS:5.10) commandName="" ;;
789N/A SunOS:5.11) commandName="exctags" ;;
789N/A Linux:*) commandName="ctags-exuberant" ;;
789N/A *) commandName="" ;;
789N/A esac
789N/A
789N/A if [ -z "${commandName}" ]
789N/A then
789N/A Error "Unable to determine Exuberant CTags command name" \
789N/A "for ${OS_NAME} ${OS_VERSION}"
789N/A return
789N/A fi
789N/A
789N/A Which "${commandName}"
789N/A}
789N/A
789N/AFindJavaHome()
789N/A{
789N/A case "${OS_NAME}:${OS_VERSION}" in
789N/A SunOS:5.10) javaHome="/usr/jdk/instances/jdk1.6.0" ;;
789N/A SunOS:5.11) javaHome="/usr/jdk/latest" ;;
857N/A Linux:*) javaHome="/usr/lib/jvm/java-6-sun" ;;
789N/A *) javaHome="" ;;
789N/A esac
789N/A
789N/A if [ -z "${javaHome}" ]
789N/A then
789N/A Error "Unable to determine Java 6 Home" \
789N/A "for ${OS_NAME} ${OS_VERSION}"
789N/A return
789N/A fi
789N/A
789N/A if [ ! -d "${javaHome}" ]
789N/A then
789N/A Error "Missing Java Home ${javaHome}"
789N/A return
789N/A fi
789N/A
789N/A echo "${javaHome}"
789N/A}
789N/A
789N/AFindApplicationServerType()
789N/A{
789N/A # Use this function to determine which environment the deploy the
789N/A # web application function into. Some users (especially
789N/A # developers) will have many deployment environments or will wish
789N/A # to specify directly the application server to deploy to.
789N/A
789N/A # Either use the environment variable OPENGROK_APP_SERVER or
789N/A # reimplement this function in your configuration file (as
789N/A # specified by OPENGROK_CONFIGURATION)
787N/A
789N/A if [ -n "${OPENGROK_APP_SERVER}" ]
789N/A then
789N/A echo "${OPENGROK_APP_SERVER}"
789N/A return
789N/A fi
789N/A
789N/A # This implementation favours Tomcat, but needs a lot of work,
789N/A # especially if Glassfish is perferrerd or it is under the control
789N/A # of SMF (Service Management Facility)
789N/A
789N/A # Maybe a better implementation would be to call Application
789N/A # Server specific WAR Directory and see if they exist.
789N/A
789N/A if [ -d "/var/tomcat6/webapps" \
789N/A -o -d "/var/lib/tomcat6/webapps" \
789N/A ]
789N/A then
789N/A echo "Tomcat"
789N/A return
789N/A fi
789N/A
789N/A if [ -x "/etc/init.d/appserv" -a -d "/var/appserver/domains" ]
789N/A then
789N/A echo "Glassfish"
789N/A return
789N/A fi
789N/A
789N/A # Assume Tomcat
789N/A echo "Tomcat"
789N/A}
789N/A
789N/ADetermineWarDirectoryTomcat()
789N/A{
789N/A if [ -n "${OPENGROK_WAR_TARGET_TOMCAT}" ]
789N/A then
789N/A echo "${OPENGROK_WAR_TARGET_TOMCAT}"
789N/A return
789N/A elif [ -n "${OPENGROK_WAR_TARGET}" ]
789N/A then
789N/A echo "${OPENGROK_WAR_TARGET}"
789N/A return
789N/A fi
789N/A
789N/A for prefix in \
789N/A ${OPENGROK_TOMCAT_BASE} \
789N/A /var/tomcat6 \
789N/A /var/lib/tomcat6 \
789N/A
789N/A do
789N/A if [ -d "${prefix}/webapps" ]
789N/A then
789N/A echo "${prefix}/webapps"
789N/A return
789N/A fi
789N/A done
789N/A}
787N/A
789N/ADetermineWarDirectoryGlassfish()
789N/A{
789N/A
789N/A if [ -n "${OPENGROK_WAR_TARGET_GLASSFISH}" ]
789N/A then
789N/A echo "${OPENGROK_WAR_TARGET_GLASSFISH}"
789N/A return
789N/A elif [ -n "${OPENGROK_WAR_TARGET}" ]
789N/A then
789N/A echo "${OPENGROK_WAR_TARGET}"
789N/A return
789N/A fi
789N/A
789N/A for prefix in \
789N/A ${OPENGROK_GLASSFISH_BASE} \
789N/A /var/appserver \
789N/A
789N/A do
789N/A if [ -d "${prefix}/domains" ]
789N/A then
789N/A if [ -z "${domainDirectory}" ]
789N/A then
789N/A domainDirectory="${prefix}/domains"
789N/A fi
789N/A fi
789N/A done
789N/A
789N/A if [ -z "${domainDirectory}" ]
789N/A then
789N/A return
789N/A fi
789N/A
789N/A # User Specified Domain
789N/A if [ -n "${OPENGROK_GLASSFISH_DOMAIN}" ]
789N/A then
789N/A directory="${domainDirectory}/${OPENGROK_GLASSFISH_DOMAIN}/autodeploy"
789N/A
789N/A if [ ! -d "${directory}" ]
789N/A then
789N/A FatalError "Missing Specified Glassfish Domain ${OPENGROK_GLASSFISH_DOMAIN}"
789N/A fi
789N/A
789N/A echo "${directory}"
789N/A return
789N/A fi
789N/A
789N/A # Arbitrary Domain Selection
789N/A firstDomain=`ls -1 ${domainDirectory} | head -1`
789N/A
789N/A if [ -z "${firstDomain}" ]
789N/A then
789N/A FatalError "Failed to dynamically determine Glassfish Domain from ${domainDirectory}"
789N/A fi
789N/A
789N/A echo "${domainDirectory}/${firstDomain}/autodeploy"
789N/A}
787N/A
294N/A#
294N/A# Implementation
294N/A#
789N/A# The variable "DO" can usefully be set to "echo" to aid in script debugging
789N/A#
294N/A
789N/ALoadStandardEnvironment()
789N/A{
789N/A # Setup a standard execution environment (if required)
789N/A
789N/A OPENGROK_STANDARD_ENV="${OPENGROK_STANDARD_ENV:-/pkgs/sbin/CronExecutionEnvironment.sh}"
789N/A
789N/A if [ -f "${OPENGROK_STANDARD_ENV}" ]
789N/A then
789N/A Progress "Loading ${OPENGROK_STANDARD_ENV} ..."
789N/A . "${OPENGROK_STANDARD_ENV}"
789N/A fi
789N/A}
789N/A
789N/ALoadInstanceConfiguration()
789N/A{
789N/A # Note: As all functions have been defined by the time this routine
789N/A # is called, your configuration can, if desired, override functions
789N/A # in addition to setting the variables mentioned in the function
789N/A # DefaultInstanceConfiguration(), this maybe useful to override
789N/A # functionality used to determine the default deployment environment
789N/A # find dependencies or validate the configuration, for example.
789N/A
789N/A if [ -n "${OPENGROK_CONFIGURATION}" -a -f "${OPENGROK_CONFIGURATION}" ]
789N/A then
789N/A # Load the Local OpenGrok Configuration Environment
789N/A Progress "Loading ${OPENGROK_CONFIGURATION} ..."
789N/A . "${OPENGROK_CONFIGURATION}"
789N/A else
789N/A Progress "Loading the default instance configuration ..."
789N/A DefaultInstanceConfiguration
789N/A fi
789N/A}
789N/A
789N/AValidateConfiguration()
789N/A{
789N/A if [ ! -x "${EXUBERANT_CTAGS}" ]
789N/A then
789N/A FatalError "Missing Dependent Application - Exuberant CTags"
789N/A fi
789N/A
789N/A if [ ! -d "${SRC_ROOT}" ]
789N/A then
789N/A FatalError "OpenGrok Source Path ${SRC_ROOT} doesn't exist"
789N/A fi
789N/A}
789N/A
789N/ACreateRuntimeRequirements()
789N/A{
789N/A if [ ! -d "${DATA_ROOT}" ]
789N/A then
789N/A Warning "OpenGrok Generated Data Path ${DATA_ROOT} doesn't exist"
789N/A Progress " Attempting to create generated data directory ... "
789N/A ${DO} mkdir -p "${DATA_ROOT}"
789N/A fi
857N/A if [ ! -d "${DATA_ROOT}" ]
857N/A then
857N/A FatalError "OpenGrok Data Path ${DATA_ROOT} doesn't exist"
857N/A fi
857N/A
857N/A if [ ! -d "${OPENGROK_INSTANCE_BASE}/etc" ]
857N/A then
857N/A Warning "OpenGrok Generated Etc Path ${OPENGROK_INSTANCE_BASE}/etc doesn't exist"
857N/A Progress " Attempting to create generated etc directory ... "
857N/A ${DO} mkdir -p "${OPENGROK_INSTANCE_BASE}/etc"
857N/A fi
857N/A if [ ! -d "${OPENGROK_INSTANCE_BASE}/etc" ]
857N/A then
857N/A FatalError "OpenGrok Etc Path ${OPENGROK_INSTANCE_BASE}/etc doesn't exist"
857N/A fi
857N/A
869N/A if [ -n "${LOGGER_CONFIG_PATH}" -a ! -f "${LOGGER_CONFIG_PATH}" ]
868N/A then
869N/A Progress " Creating default ${LOGGER_CONFIG_PATH} ... "
869N/A if [ ! -f "${LOGGER_CONF_SOURCE}" ]
869N/A then
869N/A FatalError "Can't find distribution logging configuration"
869N/A "(${LOGGER_CONF_SOURCE}) to install as default"
869N/A "logging configuration (${LOGGER_CONFIG_PATH})"
869N/A fi
869N/A
869N/A ${DO} cp "${LOGGER_CONF_SOURCE}" "${LOGGER_CONFIG_PATH}"
869N/A # TODO: Consider automatically setting the logging directory
869N/A # to within the instance base directory tree
868N/A fi
789N/A}
294N/A
294N/AStdInvocation()
294N/A{
789N/A ${DO} ${JAVA} ${JAVA_OPTS} ${PROPERTIES} \
869N/A ${LOGGER_PROPERTIES} \
789N/A -jar ${OPENGROK_JAR} \
869N/A ${IGNORE_PATTERNS} ${ENABLE_PROJECTS} \
869N/A ${DERBY_HISTORY_CACHE} \
869N/A ${SCAN_FOR_REPOSITORY} ${REMOTE_REPOSITORIES} \
868N/A ${VERBOSE} ${QUIET} \
789N/A ${EXUBERANT_CTAGS:+-c} ${EXUBERANT_CTAGS} \
869N/A ${MAX_INDEXED_WORDS} ${SKIN} ${LEADING_WILDCARD} \
789N/A -s ${SRC_ROOT} -d ${DATA_ROOT} \
789N/A "${@}"
868N/A#? -R ${XML_CONFIGURATION} \
868N/A
294N/A}
294N/A
294N/AUpdateGeneratedConfiguration()
294N/A{
869N/A StdInvocation -W ${XML_CONFIGURATION} ${WEBAPP_CONFIG_ADDRESS}
294N/A}
294N/A
294N/AUpdateGeneratedData()
294N/A{
294N/A StdInvocation -H
294N/A}
294N/A
294N/AUpdateDescriptionCache()
294N/A{
294N/A # OPTIONAL : Update the EftarFile data
789N/A
868N/A if [ -n "${PATH_DESC}" -a -s "${PATH_DESC}" ]
294N/A then
789N/A ${DO} ${JAVA} -classpath ${OPENGROK_JAR} \
789N/A ${EFTAR_UPDATE} ${PATH_DESC} ${EFTAR_OUTPUT_FILE}
294N/A fi
294N/A}
294N/A
294N/AOpenGrokUsage()
294N/A{
869N/A echo "Options for opengrok.jar:" 1>&2
294N/A ${DO} ${JAVA} ${JAVA_OPTS} -jar ${OPENGROK_JAR} '-?'
294N/A}
294N/A
787N/ADeployWar()
787N/A{
789N/A applicationServer="`FindApplicationServerType`"
789N/A
789N/A case "${applicationServer}" in
789N/A
789N/A Tomcat) warTarget="`DetermineWarDirectoryTomcat`" ;;
789N/A Glassfish) warTarget="`DetermineWarDirectoryGlassfish`" ;;
787N/A
789N/A *) FatalError "Unsupported Application Server ${applicationServer}" ;;
789N/A
789N/A esac
787N/A
789N/A if [ -z "${warTarget}" ]
789N/A then
789N/A FatalError "Unable to determine Deployment Directory for ${applicationServer}"
789N/A fi
787N/A
789N/A if [ ! -f "${OPENGROK_DIST_WAR}" ]
789N/A then
789N/A FatalError "Missing Web Application Archive ${OPENGROK_DIST_WAR}"
789N/A fi
789N/A
789N/A if [ ! -d "${warTarget}" ]
789N/A then
789N/A FatalError "Missing Deployment Directory ${warTarget}"
789N/A fi
787N/A
789N/A Progress "Installing ${OPENGROK_DIST_WAR} to ${warTarget} ..."
789N/A ${DO} cp "${OPENGROK_DIST_WAR}" "${warTarget}/"
789N/A if [ $? != 0 ]
789N/A then
789N/A FatalError "Web Application Installation FAILED"
789N/A fi
787N/A
789N/A Progress
789N/A Progress "Start your application server (${applicationServer}), if it is not already"
789N/A Progress "running, or wait until it loads the just installed web application."
789N/A Progress
789N/A Progress "OpenGrok should be available on <HOST>:<PORT>/source"
789N/A Progress " where HOST and PORT are configured in ${applicationServer}."
789N/A Progress
787N/A}
787N/A
294N/A#
294N/A# Main Program
294N/A#
294N/A
868N/Aif [ $# -eq 0 -o $# -gt 2 ]
294N/Athen
294N/A Usage
294N/Afi
294N/A
789N/ALoadStandardEnvironment
789N/A
789N/ALoadInstanceConfiguration
789N/A
294N/Acase "${1}" in
294N/A
787N/A deploy)
787N/A DeployWar
787N/A ;;
787N/A
294N/A update)
868N/A ValidateConfiguration
868N/A CreateRuntimeRequirements
789N/A UpdateGeneratedData
789N/A UpdateDescriptionCache
789N/A ;;
294N/A
294N/A updateQuietly)
868N/A ValidateConfiguration
868N/A CreateRuntimeRequirements
789N/A QUIET="-q"
789N/A VERBOSE=""
789N/A UpdateGeneratedData
789N/A UpdateDescriptionCache
789N/A ;;
294N/A
294N/A updateConfiguration)
868N/A ValidateConfiguration
868N/A CreateRuntimeRequirements
789N/A UpdateGeneratedConfiguration
789N/A ;;
294N/A
868N/A index)
869N/A if [ -n "${2}" ]
869N/A then
869N/A SRC_ROOT="${2}"
868N/A fi
868N/A ValidateConfiguration
868N/A CreateRuntimeRequirements
868N/A UpdateGeneratedConfiguration
868N/A UpdateGeneratedData
868N/A UpdateDescriptionCache
868N/A ;;
868N/A
294N/A usage)
294N/A OpenGrokUsage
868N/A Usage
789N/A ;;
294N/A
294N/A *)
294N/A Usage
789N/A ;;
294N/A
294N/Aesac
294N/A
294N/A#
294N/A# End of File
294N/A#